import Action from '@overflow/commons/redux/Action';
import AsyncNotifyPayload from '../payload/AsyncNotifyPayload';

// Action Type
export type NOTIFY = '@overflow/commons/async/notify/NOTIFY';
export const NOTIFY: NOTIFY = '@overflow/commons/async/notify/NOTIFY';

// Action Creater
export type notify = (service: string, method: string, ...args: any[]) => Action<AsyncNotifyPayload>;

export const notify: notify = (service: string, method: string, ...args: any[]): Action<AsyncNotifyPayload> => {
  return {
      type: NOTIFY,
      payload: {
        service: service,
        method: method,
        args: args,
      },
    };
};
