import Action from '@overflow/commons/redux/Action';
import AsyncRestRequestPayload from '../payload/AsyncRestRequestPayload';

// Action Type
export type REQUEST = '@overflow/commons/async/rest/REQUEST';
export const REQUEST: REQUEST = '@overflow/commons/async/rest/REQUEST';

// Action Creater
export type request = (entry: string, method: string, requestType: string, ...args: any[]) => Action<AsyncRestRequestPayload>;
export type requestSuccess = (requestType: string, result: any) => Action<any>;
export type requestFailure = (requestType: string, error: any) => Action<any>;

export const request: request = (entry: string, method: string, requestType: string, ...args: any[]): Action<AsyncRestRequestPayload> => {
  return {
    type: REQUEST,
    payload: {
      entry: entry,
      method: method,
      requestType: requestType,
      args: args,
    },
  };
};

export const requestSuccess: requestSuccess = (requestType: string, result: any): Action<any> => {
  return {
    type: `${requestType}/SUCCESS`,
    payload: result,
  };
};

export const requestFailure: requestFailure = (requestType: string, error: Error): Action<any> => {
  return {
    type: `${requestType}/FAILURE`,
    error: error,
  };
};
