import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Member from '@overflow/member/api/model/Member';

import * as ResetPasswordTypes from '../action/reset_password';
import ResetPasswordState, { defaultState as resetDefaultState } from '../state/ResetPassword';

const reducer: ReducersMapObject = {
  [ResetPasswordTypes.REQUEST_SUCCESS]: (state: ResetPasswordState = resetDefaultState, action: Action<Member>): ResetPasswordState => {
    return {
      ...state,
      isSuccess: true,
    };
  },
  [ResetPasswordTypes.REQUEST_FAILURE]: (state: ResetPasswordState = resetDefaultState, action: Action<Error>): ResetPasswordState => {
    return {
      ...state,
      error: new Error('ResetPassword Error'),
    };
  },
};

export default reducer;
