import { connect, Dispatch } from 'react-redux';
import {
    NotificationBadge,
    StateProps as StateProps,
    DispatchProps as DispatchProps,
} from './components/NotificationBadge';
import { push as routerPush } from 'react-router-redux';
import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';
import Member from '@overflow/member/api/model/Member';
import * as readUnconfirmedCntActions from '../redux/action/read_unconfirmed_count';

export function mapStateToProps(state: any, props: any): StateProps {
    return {
        count: state.count,
    };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): DispatchProps {
    return {
        onReadUnconfirmedCount: (member: Member) => {
            dispatch(asyncRequestActions.request('NotificationService', 'readUnconfirmedCount',
                                                 readUnconfirmedCntActions.REQUEST, JSON.stringify(member)));
        },
    };
}

export default connect(mapStateToProps, mapDispatchToProps)(NotificationBadge);

