import * as React from 'react';
import {
    Container,
    Popup,
    Menu,
    Icon,
    Label,
} from 'semantic-ui-react';
import Member from '@overflow/member/api/model/Member';
import NotificationPopup from '../NotificationPopup';

export interface StateProps {
    count: number;
}

export interface DispatchProps {
    onReadUnconfirmedCount(member: Member): void;
}

export type Props = StateProps & DispatchProps;

export interface State {
    opened: boolean;
}

export class NotificationBadge extends React.Component<Props, State> {

    constructor(props: Props, context: State) {
        super(props, context);
    }
    public componentWillMount(): void {
        const member: Member = {
            id: 1,
        };
        this.props.onReadUnconfirmedCount(member);
    }


    public render(): JSX.Element {
        let badge = null;
        if(this.props.count !== undefined && this.props.count > 0) {
            badge = <Label color='red'>{this.props.count}</Label>;
        }
        let icon =
            <Menu.Item position='right'>
                <Icon name='bell' />
                {badge}
            </Menu.Item>;

        return (
            <Container fluid>
                <Popup trigger={icon} on='click' wide >
                    <NotificationPopup />
                </Popup>
            </Container>
        );
    }

}
