import { connect, Dispatch } from 'react-redux';
import {
  SensorConfigTargetSelect,
  Props as SensorConfigTargetSelectStateProps,
  DispatchProps as SensorConfigTargetSelectDispatchProps,
} from './components/SensorConfigTargetSelect';
// import State from '../redux/state/ReadAllByTarget';
import { push as routerPush } from 'react-router-redux';

// import Target from '@overflow/target/api/model/Target';
// import Sensor from '@overflow/sensor/api/model/Sensor';
// import SensorItem from '@overflow/sensor/api/model/SensorItem';
import Domain from '@overflow/domain/api/model/Domain';
import PageParams from '@overflow/commons/api/model/PageParams';

import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';
import * as targetListActions from '@overflow/target/redux/action/read_all_by_probe';
import * as readActionType from '@overflow/infra/redux/action/read';

export function mapStateToProps(state: any, props: any): SensorConfigTargetSelectStateProps {
  return {
    infraList: state.infraList,
    infra: state.infra,
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): SensorConfigTargetSelectDispatchProps {
  return {
    onReadAllTargetByDomain: (domain: Domain, pageParams: PageParams) => {
      dispatch(asyncRequestActions.request('InfraService', 'readAllByDomain', targetListActions.REQUEST,
                                           JSON.stringify(domain), JSON.stringify(pageParams)));
    },
    onReadInfra: (infraId: number) => {
      dispatch(asyncRequestActions.request('InfraService', 'read', readActionType.REQUEST, infraId));
    },
  };
}


export default connect(mapStateToProps, mapDispatchToProps)(SensorConfigTargetSelect);
